<?php

class MixiGraphApi {
    private $apiUrl;
    private $apiResult;
    private $requestHeader = array();
    private $requestBody   = array();
    private $accessToken;
    private $httpCode;

    // TODO:constは必要に応じて、設定ファイルより取得するよう修正

    // 基本設定
    const consumerKey    = '2bb7133e5e50818232d2';
    const consumerSecret = 'ed6fec9b83f6f5b9e236576328f54e0f915b6746';
    const callBackUrl    = 'http://svh36.sunbridge.com/mixi/callback.php';

    // アクセストークン取得関連
    const endPointUrlToken  = 'https://secure.mixi-platform.com/2/token';
    // デバッグ用stub url
    //const endPointUrlToken  = 'http://svh36.sunbridge.com/mixi/stub/token.php';
    const grantType         = 'authorization_code';

    // チェック投稿関連
    const endPointUrlCheck  = 'http://api.mixi-platform.com/2/share';
    // デバッグ用stub url
    //const endPointUrlCheck  = 'http://svh36.sunbridge.com/mixi/stub/share.php';
    const pluginPageKey     = 'c985a438bbba58cb0e82bdcf3cd9106519fcef3a';
    const privacyVisibility = 'self';   // チェックの公開範囲
                                        // friends_of_friends : 友人の友人まで公開
                                        // friends            : 友人まで公開
                                        // top_friends        : 仲良しまで公開
                                        // group              : 特定のグループに公開
                                        // self               : 非公開

    // アクセストークン取得API呼び出し
    public function callTokenApi($code) {
        if (empty($code)){
            // throw exception ?
        }

        $this->apiUrl      = self::endPointUrlToken;
        $this->requestBody = array(
            'grant_type'    => self::grantType,
            'client_id'     => self::consumerKey,
            'client_secret' => self::consumerSecret,
            'code'          => $code,
            'redirect_uri'  => self::callBackUrl
        );
        $this->_callApi();

        $json = json_decode($this->apiResult);
        if (array_key_exists('access_token', $json)) {
            $token = $json->{'access_token'};
        } else {
            // throw exception ?
        }

        return $token;
    }

    // OAuth認証用HTTPヘッダ設定
    public function setOAuthHeader($token) {
        if (empty($token)){
            // throw exception ?
        }
        $this->accessToken   = $token;
        $this->requestHeader = array(
            "Authorization: OAuth " . $this->accessToken,
            "Content-Type: application/json; charset=utf8"
        );
    }

    // チェック投稿API呼び出し
    public function callCheckApi($param) {
        if (empty($this->accessToken)) {
            // throw exception ?
        }

        $this->apiUrl = self::endPointUrlCheck;
        $param['primary_url'] = self::callBackUrl;
        $param['pc_url']      = self::callBackUrl;
        $param['key']         = self::pluginPageKey;
        $param['privacy']     = array('visibility' => self::privacyVisibility);
        $this->_callApiByJson($param);
    }

    // HTTPステータスコード取得
    public function getHttpCode() {
        if (empty($this->httpCode)) {
            return;
        }
        return $this->httpCode;
    }

    // JsonパラメータAPI呼び出し
    private function _callApiByJson($param) {
        $this->requestBody = json_encode($param);
        $this->_callApi();
    }

    // API呼び出し
    private function _callApi() {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->apiUrl);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        if (count($this->requestHeader)) {
            curl_setopt($ch, CURLOPT_HTTPHEADER, $this->requestHeader);
        }
        if (!empty($this->requestBody)) {
            curl_setopt($ch, CURLOPT_POSTFIELDS, $this->requestBody);
        }
        $this->apiResult = curl_exec($ch);
        $this->httpCode  = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);

        if ($this->httpCode != 200) {
            // throw exception ?
        }
    }

}
